<?php
$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] = (@$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] ?: array()) + array("_5c535722540e1ef86eee" . "de2274ec9cd4" => base64_decode("Ojo" . "="), "_58d506edba9ce80af6a06" . "1b73e2eb66c" => base64_decode("X" . "w" . "=" . "="), "_49c6565477ee9f822b499a53e6" . "d2995f" => base64_decode("YXJyYXlfa2V5X2V4aXN0cw" . "=="), "da" . "ta" => base64_decode("ZGF" . "0YQ" . "=="), "_96be32a6f44bf5" . "4e635e1736acf7a" . "96c" => base64_decode("c2Vya" . "WFsaX" . "pl"), "_dd9ca86d31061e4b7184cacc55c" . "a7683" => base64_decode("Xz" . "o6"), "_0c519e721cc3079fbb25" . "2fbd60fd7904" => base64_decode("dGl" . "tZQ" . "=="), "_fc92ae3f94d" . "b68f127405f0" . "1245b1990" => base64_decode("Q2xhQ2Fj" . "aGVNZW1v" . "cnkucGhw"), "_c244a470df52d1d5a7085138e" . "c94e393" => base64_decode("dW5z" . "ZXJp" . "YWxp" . "emU="), "_040eaefa66260cc2ea" . "eebf3fb7e20ed1" => base64_decode("dQ" . "=="), "_2accea7fbc17e2f135b1" . "97a5b6ff0992" => base64_decode("ZX" . "hw"), "_7f628626dd1d55c71b1fc0932ffd1" . "d2c" => base64_decode("aXNf" . "YXJy" . "YXk="), "_f61cbfe09f839854b95117fe13b4a" . "1ba" => base64_decode("c3" . "Ry" . "cG" . "9z"), "_aed8da0f19091214b78f803" . "51048517c" => base64_decode("c3Ryb" . "GVu"));














class ClaCache
{
    const NONE = 0;
    const REQUEST = 1;
    const SESSION = 2;
    const MEMORY_USER = 4;
    const MEMORY = 8;
    const PRIMARY_CACHES = [ClaCache::REQUEST, ClaCache::MEMORY, ClaCache::MEMORY_USER, ClaCache::SESSION];
    
    
    
    
    const C_USER = 6;
    
    
    
    
    
    
    const C_SHARED = 10;
    
    
    
    
    
    const C_SHORT = 1;
    
    
    
    
    
    const C_USER_SHORT = 1;
    
    
    protected static $cache_handlers = array();
    
    
    
    
    
    
    public static function I($type)
    {
        if (!isset(self::$cache_handlers[$type])) {
            $_ec22de4ba29ca0ee83a7743d1d341df4 = null;
            if (!$_ec22de4ba29ca0ee83a7743d1d341df4 && $type & self::MEMORY) {
                require_once $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_fc92ae3f" . "94db68f12" . "7405f0124" . "5b1990"];
                $_ec22de4ba29ca0ee83a7743d1d341df4 = ClaCacheMemory::Create(true);
            }
            if (!$_ec22de4ba29ca0ee83a7743d1d341df4 && $type & self::MEMORY_USER) {
                require_once $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_fc92ae3" . "f94db68f" . "127405f0" . "1245b199" . "0"];
                $_ec22de4ba29ca0ee83a7743d1d341df4 = ClaCacheMemory::Create(false);
            }
            if (!$_ec22de4ba29ca0ee83a7743d1d341df4 && $type & self::SESSION) {
                $_ec22de4ba29ca0ee83a7743d1d341df4 = new ClaCacheSession();
            }
            if (!$_ec22de4ba29ca0ee83a7743d1d341df4 && $type & self::REQUEST) {
                $_ec22de4ba29ca0ee83a7743d1d341df4 = new ClaCacheRequest();
            }
            if (!$_ec22de4ba29ca0ee83a7743d1d341df4) {
                $_ec22de4ba29ca0ee83a7743d1d341df4 = new ClaCacheNone();
            }
            self::$cache_handlers[$type] = $_ec22de4ba29ca0ee83a7743d1d341df4;
        }
        return self::$cache_handlers[$type];
    }
    
    
    
    
    
    
    
    
    public static function Get($key, $_8ea414bcd8dd59cbdda78334bb203848 = false)
    {
        return self::I($_8ea414bcd8dd59cbdda78334bb203848 ? self::C_SHARED : self::C_USER)->Get($key);
    }
    
    
    
    
    
    
    
    
    public static function GetGlobal($key)
    {
        return self::I(self::C_SHARED)->Get($key);
    }
    
    
    
    
    
    
    
    
    
    
    
    public static function Set($key, $data, $_8ea414bcd8dd59cbdda78334bb203848 = false, $ttl = 0)
    {
        return self::I($_8ea414bcd8dd59cbdda78334bb203848 ? self::C_SHARED : self::C_USER)->Set($key, $data, $ttl);
    }
    
    
    
    
    
    
    
    
    
    
    public static function SetGlobal($key, $data, $ttl = 0)
    {
        return self::I(self::C_SHARED)->Set($key, $data, $ttl);
    }
    
    
    
    
    
    
    
    
    public static function Delete($key, $_8ea414bcd8dd59cbdda78334bb203848 = false)
    {
        return self::I($_8ea414bcd8dd59cbdda78334bb203848 ? self::C_SHARED : self::C_USER)->Delete($key);
    }
    
    
    
    
    
    
    
    public static function DeleteGlobal($key)
    {
        return self::I(self::C_SHARED)->Delete($key);
    }
    
    
    
    
    
    
    
    
    public static function Clear($namespace = '', $_8ea414bcd8dd59cbdda78334bb203848 = false)
    {
        return self::I($_8ea414bcd8dd59cbdda78334bb203848 ? self::C_SHARED : self::C_USER)->Clear($namespace);
    }
    
    
    
    
    
    
    
    
    public static function ClearGlobal($namespace = '')
    {
        return self::I(self::C_SHARED)->Clear($namespace);
    }
}
interface ClaCacheHandler
{
    public function Get($key);
    public function Set($key, $data, $ttl = 0);
    public function Delete($key);
    public function Clear($namespace);
}




class ClaCacheNone implements ClaCacheHandler
{
    public function Get($key)
    {
        return null;
    }
    public function Set($key, $data, $ttl = 0)
    {
        return false;
    }
    public function Delete($key)
    {
        return true;
    }
    public function Clear($namespace)
    {
        return true;
    }
}





class ClaCacheMemoryUserDecorator implements ClaCacheHandler
{
    protected $handler;
    public function __construct(ClaCacheHandler $_ec22de4ba29ca0ee83a7743d1d341df4)
    {
        $this->handler = $_ec22de4ba29ca0ee83a7743d1d341df4;
    }
    
    
    
    
    
    
    
    protected static function AddUserNamespace($key)
    {
        if ($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_f61cbfe09f839854b9" . "5117fe13b4a1ba"]($key, $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_5c535722540e1ef86eeede2274ec9cd" . "4"]) > 0) {
            return $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_040eaefa66260cc2e" . "aeebf3fb7e20ed1"] . AuthUser::I()->GetId() . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_58d506edb" . "a9ce80af6a" . "061b73e2eb" . "66c"] . $key;
        }
        return $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_040eaefa66260cc2eaeebf3fb7e20" . "ed1"] . AuthUser::I()->GetId() . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_dd9ca86d31061e4b7184cac" . "c55ca7683"] . $key;
    }
    public function Get($key)
    {
        return $this->handler->Get(self::AddUserNamespace($key));
    }
    public function Set($key, $data, $ttl = 0)
    {
        return $this->handler->Set(self::AddUserNamespace($key), $data, $ttl);
    }
    public function Delete($key)
    {
        return $this->handler->Delete(self::AddUserNamespace($key));
    }
    public function Clear($namespace)
    {
        $namespace = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_040eaefa66260cc2eaeebf3fb7e" . "20ed1"] . AuthUser::I()->GetId() . $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_58d506edba9ce80a" . "f6a061b73e2eb66c"] . $namespace;
        return $this->handler->Clear($namespace);
    }
}




abstract class ClaCacheArray implements ClaCacheHandler
{
    
    
    
    
    protected $storage;
    protected $size_limit;
    public function __construct(&$_ee97244432473014aa9408ee5cf1f596, $_8dc3695d96441e6155a6428d9b21abaa)
    {
        $this->storage =& $_ee97244432473014aa9408ee5cf1f596;
        $this->size_limit = $_8dc3695d96441e6155a6428d9b21abaa;
    }
    public function Get($key)
    {
        if (isset($this->storage[$key])) {
            $value = $this->storage[$key];
            if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_7f628626dd1d55c" . "71b1fc0932ffd1d2" . "c"]($value) && $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_49c6565477e" . "e9f822b499a5" . "3e6d2995f"]($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_2accea7fbc17" . "e2f135b197a5b" . "6ff0992"], $value) && $value[$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_2accea7fbc17e" . "2f135b197a5b6f" . "f0992"]] > $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_0c519e721cc3079" . "fbb252fbd60fd790" . "4"]() && $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_49c6565477ee9f822b499a53e6d2" . "995f"]($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["dat" . "a"], $value)) {
                return $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_c244a470df52d1d5a" . "7085138ec94e393"]($value[$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["d" . "a" . "t" . "a"]]);
            }
            $this->Delete($key);
        }
        return null;
    }
    public function Set($key, $data, $ttl = 0)
    {
        
        
        $_2accea7fbc17e2f135b197a5b6ff0992 = $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_0c519e721cc3079fbb252fbd60" . "fd7904"]() + ($ttl > 0 ? $ttl : 3600 * 24 * 10);
        $this->storage[$key] = [$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_2accea7f" . "bc17e2f13" . "5b197a5b6" . "ff0992"] => $_2accea7fbc17e2f135b197a5b6ff0992, $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["da" . "ta"] => $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_96be32a6f44bf54e63" . "5e1736acf7a96c"]($data)];
        return true;
    }
    public function Delete($key)
    {
        if (isset($this->storage[$key])) {
            unset($this->storage[$key]);
        }
        return true;
    }
    public function Clear($namespace)
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_aed8da0f19" . "091214b78f8" . "0351048517c"]($namespace) == 0) {
            $this->storage = array();
        } else {
            $this->storage = array();
        }
        
        
    }
}




class ClaCacheSession extends ClaCacheArray
{
    const KEY = 'CC';
    public function __construct()
    {
        if (!isset($_SESSION[self::KEY])) {
            $_SESSION[self::KEY] = array();
        }
        parent::__construct($_SESSION[self::KEY], null);
    }
}




class ClaCacheRequest extends ClaCacheArray
{
    static $static_storage = array();
    public function __construct()
    {
        parent::__construct(self::$static_storage, null);
    }
}